// -*- C++ -*-
/*!
 * @file  Robot_position.h
 * @brief ModuleDescription
 * @date  $Date$
 *
 * $Id$
 */

#ifndef ROBOT_POSITION_H
#define ROBOT_POSITION_H
#define samples_number 5

#include <rtm/idl/BasicDataTypeSkel.h>
#include <rtm/idl/ExtendedDataTypesSkel.h>
#include <rtm/idl/InterfaceDataTypesSkel.h>

// Service implementation headers
// <rtc-template block="service_impl_h">

// </rtc-template>

// Service Consumer stub headers
// <rtc-template block="consumer_stub_h">

// </rtc-template>

// Service Consumer stub headers
// <rtc-template block="port_stub_h">
// </rtc-template>

#include <rtm/Manager.h>
#include <rtm/DataFlowComponentBase.h>
#include <rtm/CorbaPort.h>
#include <rtm/DataInPort.h>
#include <rtm/DataOutPort.h>

using namespace RTC;

/*!
 * @class Robot_position
 * @brief ModuleDescription
 *
 */
class Robot_position
  : public RTC::DataFlowComponentBase
{
 public:
  /*!
   * @brief constructor
   * @param manager Maneger Object
   */
  Robot_position(RTC::Manager* manager);

  /*!
   * @brief destructor
   */
  ~Robot_position();

  // <rtc-template block="public_attribute">
  
  // </rtc-template>

  // <rtc-template block="public_operation">
  
  // </rtc-template>

  /***
   *
   * The initialize action (on CREATED->ALIVE transition)
   * formaer rtc_init_entry() 
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
   virtual RTC::ReturnCode_t onInitialize();

  /***
   *
   * The finalize action (on ALIVE->END transition)
   * formaer rtc_exiting_entry()
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
  // virtual RTC::ReturnCode_t onFinalize();

  /***
   *
   * The startup action when ExecutionContext startup
   * former rtc_starting_entry()
   *
   * @param ec_id target ExecutionContext Id
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
  // virtual RTC::ReturnCode_t onStartup(RTC::UniqueId ec_id);

  /***
   *
   * The shutdown action when ExecutionContext stop
   * former rtc_stopping_entry()
   *
   * @param ec_id target ExecutionContext Id
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
  // virtual RTC::ReturnCode_t onShutdown(RTC::UniqueId ec_id);

  /***
   *
   * The activated action (Active state entry action)
   * former rtc_active_entry()
   *
   * @param ec_id target ExecutionContext Id
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
   virtual RTC::ReturnCode_t onActivated(RTC::UniqueId ec_id);

  /***
   *
   * The deactivated action (Active state exit action)
   * former rtc_active_exit()
   *
   * @param ec_id target ExecutionContext Id
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
   virtual RTC::ReturnCode_t onDeactivated(RTC::UniqueId ec_id);

  /***
   *
   * The execution action that is invoked periodically
   * former rtc_active_do()
   *
   * @param ec_id target ExecutionContext Id
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
   virtual RTC::ReturnCode_t onExecute(RTC::UniqueId ec_id);

  /***
   *
   * The aborting action when main logic error occurred.
   * former rtc_aborting_entry()
   *
   * @param ec_id target ExecutionContext Id
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
  // virtual RTC::ReturnCode_t onAborting(RTC::UniqueId ec_id);

  /***
   *
   * The error action in ERROR state
   * former rtc_error_do()
   *
   * @param ec_id target ExecutionContext Id
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
  // virtual RTC::ReturnCode_t onError(RTC::UniqueId ec_id);

  /***
   *
   * The reset action that is invoked resetting
   * This is same but different the former rtc_init_entry()
   *
   * @param ec_id target ExecutionContext Id
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
  // virtual RTC::ReturnCode_t onReset(RTC::UniqueId ec_id);
  
  /***
   *
   * The state update action that is invoked after onExecute() action
   * no corresponding operation exists in OpenRTm-aist-0.2.0
   *
   * @param ec_id target ExecutionContext Id
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
  // virtual RTC::ReturnCode_t onStateUpdate(RTC::UniqueId ec_id);

  /***
   *
   * The action that is invoked when execution context's rate is changed
   * no corresponding operation exists in OpenRTm-aist-0.2.0
   *
   * @param ec_id target ExecutionContext Id
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
  // virtual RTC::ReturnCode_t onRateChanged(RTC::UniqueId ec_id);


 protected:

	 double theta;
	 double field[1024];
	 double range[1024];

	 short right_count;
	 short left_count;

	 double right_theta;
	 double right_x;
	 double right_y;

	 double left_theta;
	 double left_x;
	 double left_y;

	 double middle_x;
	 double middle_y;

	 double robot_direction;
	 double position_x;
	 double position_y;

	 double position_array_x[samples_number];
	 double position_array_y[samples_number];
	 double direction_array[samples_number];

	 double a, b;

	 short calc_count;

	 double Average(const double arr[], int length);

  // <rtc-template block="protected_attribute">
  
  // </rtc-template>

  // <rtc-template block="protected_operation">
  
  // </rtc-template>

  // Configuration variable declaration
  // <rtc-template block="config_declare">
  /*!
   * 
   * - Name:  LRFdata_min
   * - DefaultValue: 84
   */
  int m_LRFdata_min;
  /*!
   * 
   * - Name:  LRFdata_mid
   * - DefaultValue: 347
   */
  int m_LRFdata_mid;
  /*!
   * 
   * - Name:  LRFdata_max
   * - DefaultValue: 610
   */
  int m_LRFdata_max;
  /*!
   * 
   * - Name:  right_corner
   * - DefaultValue: 271
   */
  int m_right_corner;
  /*!
   * 
   * - Name:  left_corner
   * - DefaultValue: 423
   */
  int m_left_corner;
  /*!
   * 
   * - Name:  LRF_total_steps
   * - DefaultValue: 1024
   */
  int m_LRF_total_steps;
  /*!
   * 
   * - Name:  LRFdata_theta
   * - DefaultValue: 360
   */
  int m_LRFdata_theta;
  /*!
   * 
   * - Name:  robot_width
   * - DefaultValue: 50
   */
  int m_robot_width;
  /*!
   * 
   * - Name:  field_width
   * - DefaultValue: 1000
   */
  int m_field_width;
  /*!
   * 
   * - Name:  field_depth
   * - DefaultValue: 2000
   */
  int m_field_depth;
  /*!
   * 
   * - Name:  robot_board_distance
   * - DefaultValue: 100
   */
  double m_robot_board_distance;

  // </rtc-template>

  // DataInPort declaration
  // <rtc-template block="inport_declare">
  RTC::RangeData m_range_data;
  /*!
   */
  InPort<RTC::RangeData> m_range_dataIn;
  
  // </rtc-template>


  // DataOutPort declaration
  // <rtc-template block="outport_declare">
  RTC::TimedDouble m_position_X;
  /*!
   */
  OutPort<RTC::TimedDouble> m_position_XOut;
  RTC::TimedDouble m_position_Y;
  /*!
   */
  OutPort<RTC::TimedDouble> m_position_YOut;
  RTC::TimedDouble m_direction;
  /*!
   */
  OutPort<RTC::TimedDouble> m_directionOut;
  
  // </rtc-template>

  // CORBA Port declaration
  // <rtc-template block="corbaport_declare">
  
  // </rtc-template>

  // Service declaration
  // <rtc-template block="service_declare">
  
  // </rtc-template>

  // Consumer declaration
  // <rtc-template block="consumer_declare">
  
  // </rtc-template>

 private:
  // <rtc-template block="private_attribute">
  
  // </rtc-template>

  // <rtc-template block="private_operation">
  
  // </rtc-template>

};


extern "C"
{
  DLL_EXPORT void Robot_positionInit(RTC::Manager* manager);
};

#endif // ROBOT_POSITION_H
